Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/AlbaEncoding.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/AlbaEncoding.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/AlbaEncoding.cs	(revision 15018)
@@ -106,5 +106,5 @@
 
     [StorableConstructor]
-    protected AlbaEncoding(bool serializing)
+    protected AlbaEncoding(StorableConstructorFlag serializing)
       : base(serializing) {
     }
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Creators/AlbaCreator.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Creators/AlbaCreator.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Creators/AlbaCreator.cs	(revision 15018)
@@ -35,5 +35,5 @@
 
     [StorableConstructor]
-    protected AlbaCreator(bool deserializing) : base(deserializing) { }
+    protected AlbaCreator(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaCreator()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Creators/RandomCreator.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Creators/RandomCreator.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Creators/RandomCreator.cs	(revision 15018)
@@ -38,5 +38,5 @@
 
     [StorableConstructor]
-    private RandomCreator(bool deserializing) : base(deserializing) { }
+    private RandomCreator(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public RandomCreator()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Crossovers/AlbaCrossover.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Crossovers/AlbaCrossover.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Crossovers/AlbaCrossover.cs	(revision 15018)
@@ -37,5 +37,5 @@
 
     [StorableConstructor]
-    protected AlbaCrossover(bool deserializing)
+    protected AlbaCrossover(StorableConstructorFlag deserializing)
       : base(deserializing) {
     }
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Crossovers/AlbaPermutationCrossover.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Crossovers/AlbaPermutationCrossover.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Crossovers/AlbaPermutationCrossover.cs	(revision 15018)
@@ -35,5 +35,5 @@
 
     [StorableConstructor]
-    private AlbaPermutationCrossover(bool deserializing) : base(deserializing) { }
+    private AlbaPermutationCrossover(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaPermutationCrossover()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/LocalImprovement/AlbaLambdaInterchangeLocalImprovementOperator.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/LocalImprovement/AlbaLambdaInterchangeLocalImprovementOperator.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/LocalImprovement/AlbaLambdaInterchangeLocalImprovementOperator.cs	(revision 15018)
@@ -71,5 +71,5 @@
 
     [StorableConstructor]
-    protected AlbaLambdaInterchangeLocalImprovementOperator(bool deserializing) : base(deserializing) { }
+    protected AlbaLambdaInterchangeLocalImprovementOperator(StorableConstructorFlag deserializing) : base(deserializing) { }
     protected AlbaLambdaInterchangeLocalImprovementOperator(AlbaLambdaInterchangeLocalImprovementOperator original, Cloner cloner)
       : base(original, cloner) {
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaCustomerInsertionManipulator.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaCustomerInsertionManipulator.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaCustomerInsertionManipulator.cs	(revision 15018)
@@ -29,5 +29,5 @@
   public sealed class AlbaCustomerInsertionManipulator : AlbaManipulator {
     [StorableConstructor]
-    private AlbaCustomerInsertionManipulator(bool deserializing) : base(deserializing) { }
+    private AlbaCustomerInsertionManipulator(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaCustomerInsertionManipulator()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaCustomerInversionManipulator.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaCustomerInversionManipulator.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaCustomerInversionManipulator.cs	(revision 15018)
@@ -30,5 +30,5 @@
   public sealed class AlbaCustomerInversionManipulator : AlbaManipulator {
     [StorableConstructor]
-    private AlbaCustomerInversionManipulator(bool deserializing) : base(deserializing) { }
+    private AlbaCustomerInversionManipulator(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaCustomerInversionManipulator()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaCustomerSwapManipulator.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaCustomerSwapManipulator.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaCustomerSwapManipulator.cs	(revision 15018)
@@ -29,5 +29,5 @@
   public sealed class AlbaCustomerSwapManipulator : AlbaManipulator {
     [StorableConstructor]
-    private AlbaCustomerSwapManipulator(bool deserializing) : base(deserializing) { }
+    private AlbaCustomerSwapManipulator(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaCustomerSwapManipulator()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaIntraRouteInversionManipulator.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaIntraRouteInversionManipulator.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaIntraRouteInversionManipulator.cs	(revision 15018)
@@ -30,5 +30,5 @@
   public sealed class AlbaIntraRouteInversionManipulator : AlbaManipulator {
     [StorableConstructor]
-    private AlbaIntraRouteInversionManipulator(bool deserializing) : base(deserializing) { }
+    private AlbaIntraRouteInversionManipulator(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaIntraRouteInversionManipulator()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaLambdaInterchangeManipulator.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaLambdaInterchangeManipulator.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaLambdaInterchangeManipulator.cs	(revision 15018)
@@ -37,5 +37,5 @@
 
     [StorableConstructor]
-    private AlbaLambdaInterchangeManipulator(bool deserializing) : base(deserializing) { }
+    private AlbaLambdaInterchangeManipulator(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaLambdaInterchangeManipulator()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaManipulator.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaManipulator.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaManipulator.cs	(revision 15018)
@@ -37,5 +37,5 @@
 
     [StorableConstructor]
-    protected AlbaManipulator(bool deserializing) : base(deserializing) { }
+    protected AlbaManipulator(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaManipulator()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaPermutationManipulator.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaPermutationManipulator.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Manipulators/AlbaPermutationManipulator.cs	(revision 15018)
@@ -35,5 +35,5 @@
 
     [StorableConstructor]
-    private AlbaPermutationManipualtor(bool deserializing) : base(deserializing) { }
+    private AlbaPermutationManipualtor(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaPermutationManipualtor()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/AlbaMoveEvaluator.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/AlbaMoveEvaluator.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/AlbaMoveEvaluator.cs	(revision 15018)
@@ -30,5 +30,5 @@
   public abstract class AlbaMoveEvaluator : VRPMoveEvaluator, IAlbaOperator {
     [StorableConstructor]
-    protected AlbaMoveEvaluator(bool deserializing) : base(deserializing) { }
+    protected AlbaMoveEvaluator(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaMoveEvaluator()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/AlbaMoveGenerator.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/AlbaMoveGenerator.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/AlbaMoveGenerator.cs	(revision 15018)
@@ -31,5 +31,5 @@
   public abstract class AlbaMoveGenerator : VRPMoveGenerator, IAlbaOperator {
     [StorableConstructor]
-    protected AlbaMoveGenerator(bool deserializing) : base(deserializing) { }
+    protected AlbaMoveGenerator(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaMoveGenerator()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/AlbaMoveMaker.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/AlbaMoveMaker.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/AlbaMoveMaker.cs	(revision 15018)
@@ -30,5 +30,5 @@
   public abstract class AlbaMoveMaker : VRPMoveMaker, IAlbaOperator {
     [StorableConstructor]
-    protected AlbaMoveMaker(bool deserializing) : base(deserializing) { }
+    protected AlbaMoveMaker(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaMoveMaker()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaExhaustiveIntraRouteInversionMoveGenerator.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaExhaustiveIntraRouteInversionMoveGenerator.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaExhaustiveIntraRouteInversionMoveGenerator.cs	(revision 15018)
@@ -32,5 +32,5 @@
   public sealed class AlbaExhaustiveIntraRouteInversionGenerator : AlbaIntraRouteInversionMoveGenerator, IExhaustiveMoveGenerator, IAlbaIntraRouteInversionMoveOperator {
     [StorableConstructor]
-    private AlbaExhaustiveIntraRouteInversionGenerator(bool deserializing) : base(deserializing) { }
+    private AlbaExhaustiveIntraRouteInversionGenerator(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaExhaustiveIntraRouteInversionGenerator()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaIntraRouteInversionEvaluator.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaIntraRouteInversionEvaluator.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaIntraRouteInversionEvaluator.cs	(revision 15018)
@@ -39,5 +39,5 @@
 
     [StorableConstructor]
-    private AlbaIntraRouteInversionMoveEvaluator(bool deserializing) : base(deserializing) { }
+    private AlbaIntraRouteInversionMoveEvaluator(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaIntraRouteInversionMoveEvaluator()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaIntraRouteInversionMove.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaIntraRouteInversionMove.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaIntraRouteInversionMove.cs	(revision 15018)
@@ -35,5 +35,5 @@
 
     [StorableConstructor]
-    protected AlbaIntraRouteInversionMove(bool deserializing) : base(deserializing) { }
+    protected AlbaIntraRouteInversionMove(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     protected AlbaIntraRouteInversionMove(AlbaIntraRouteInversionMove original, Cloner cloner)
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaIntraRouteInversionMoveGenerator.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaIntraRouteInversionMoveGenerator.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaIntraRouteInversionMoveGenerator.cs	(revision 15018)
@@ -44,5 +44,5 @@
 
     [StorableConstructor]
-    protected AlbaIntraRouteInversionMoveGenerator(bool deserializing) : base(deserializing) { }
+    protected AlbaIntraRouteInversionMoveGenerator(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaIntraRouteInversionMoveGenerator()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaIntraRouteInversionMoveMaker.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaIntraRouteInversionMoveMaker.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaIntraRouteInversionMoveMaker.cs	(revision 15018)
@@ -39,5 +39,5 @@
 
     [StorableConstructor]
-    protected AlbaIntraRouteInversionMoveMaker(bool deserializing) : base(deserializing) { }
+    protected AlbaIntraRouteInversionMoveMaker(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaIntraRouteInversionMoveMaker()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaStochasticIntraRouteInversionMutliMoveGenerator.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaStochasticIntraRouteInversionMutliMoveGenerator.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaStochasticIntraRouteInversionMutliMoveGenerator.cs	(revision 15018)
@@ -43,5 +43,5 @@
 
     [StorableConstructor]
-    private AlbaStochasticIntraRouteInversionMultiMoveGenerator(bool deserializing) : base(deserializing) { }
+    private AlbaStochasticIntraRouteInversionMultiMoveGenerator(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaStochasticIntraRouteInversionMultiMoveGenerator()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaStochasticIntraRouteInversionSingleMoveGenerator.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaStochasticIntraRouteInversionSingleMoveGenerator.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/IntraRouteInversion/AlbaStochasticIntraRouteInversionSingleMoveGenerator.cs	(revision 15018)
@@ -46,5 +46,5 @@
 
     [StorableConstructor]
-    private AlbaStochasticIntraRouteInversionSingleMoveGenerator(bool deserializing) : base(deserializing) { }
+    private AlbaStochasticIntraRouteInversionSingleMoveGenerator(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaStochasticIntraRouteInversionSingleMoveGenerator()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaExhaustiveLambdaInterchangeMoveGenerator.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaExhaustiveLambdaInterchangeMoveGenerator.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaExhaustiveLambdaInterchangeMoveGenerator.cs	(revision 15018)
@@ -33,5 +33,5 @@
   public sealed class AlbaExhaustiveLambdaInterchangeMoveGenerator : AlbaLambdaInterchangeMoveGenerator, IExhaustiveMoveGenerator, IAlbaLambdaInterchangeMoveOperator {
     [StorableConstructor]
-    private AlbaExhaustiveLambdaInterchangeMoveGenerator(bool deserializing) : base(deserializing) { }
+    private AlbaExhaustiveLambdaInterchangeMoveGenerator(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaExhaustiveLambdaInterchangeMoveGenerator()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaLambdaInterchangeMove.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaLambdaInterchangeMove.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaLambdaInterchangeMove.cs	(revision 15018)
@@ -79,5 +79,5 @@
 
     [StorableConstructor]
-    protected AlbaLambdaInterchangeMove(bool deserializing) : base(deserializing) { }
+    protected AlbaLambdaInterchangeMove(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaLambdaInterchangeMoveEvaluator.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaLambdaInterchangeMoveEvaluator.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaLambdaInterchangeMoveEvaluator.cs	(revision 15018)
@@ -39,5 +39,5 @@
 
     [StorableConstructor]
-    private AlbaLambdaInterchangeMoveEvaluator(bool deserializing) : base(deserializing) { }
+    private AlbaLambdaInterchangeMoveEvaluator(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaLambdaInterchangeMoveEvaluator()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaLambdaInterchangeMoveGenerator.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaLambdaInterchangeMoveGenerator.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaLambdaInterchangeMoveGenerator.cs	(revision 15018)
@@ -53,5 +53,5 @@
 
     [StorableConstructor]
-    protected AlbaLambdaInterchangeMoveGenerator(bool deserializing) : base(deserializing) { }
+    protected AlbaLambdaInterchangeMoveGenerator(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaLambdaInterchangeMoveGenerator()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaLambdaInterchangeMoveMaker.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaLambdaInterchangeMoveMaker.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaLambdaInterchangeMoveMaker.cs	(revision 15018)
@@ -42,5 +42,5 @@
 
     [StorableConstructor]
-    protected AlbaLambdaInterchangeMoveMaker(bool deserializing) : base(deserializing) { }
+    protected AlbaLambdaInterchangeMoveMaker(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaLambdaInterchangeMoveMaker()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaStochasticLambdaInterchangeMutliMoveGenerator.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaStochasticLambdaInterchangeMutliMoveGenerator.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaStochasticLambdaInterchangeMutliMoveGenerator.cs	(revision 15018)
@@ -43,5 +43,5 @@
 
     [StorableConstructor]
-    private AlbaStochasticLambdaInterchangeMultiMoveGenerator(bool deserializing) : base(deserializing) { }
+    private AlbaStochasticLambdaInterchangeMultiMoveGenerator(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaStochasticLambdaInterchangeMultiMoveGenerator()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaStochasticLambdaInterchangeSingleMoveGenerator.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaStochasticLambdaInterchangeSingleMoveGenerator.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/LambdaInterchange/AlbaStochasticLambdaInterchangeSingleMoveGenerator.cs	(revision 15018)
@@ -47,5 +47,5 @@
 
     [StorableConstructor]
-    private AlbaStochasticLambdaInterchangeSingleMoveGenerator(bool deserializing) : base(deserializing) { }
+    private AlbaStochasticLambdaInterchangeSingleMoveGenerator(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaStochasticLambdaInterchangeSingleMoveGenerator()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/ThreeOpt/AlbaStochasticTranslocationSingleMoveGenerator.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/ThreeOpt/AlbaStochasticTranslocationSingleMoveGenerator.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/ThreeOpt/AlbaStochasticTranslocationSingleMoveGenerator.cs	(revision 15018)
@@ -55,5 +55,5 @@
 
     [StorableConstructor]
-    private AlbaStochasticTranslocationSingleMoveGenerator(bool deserializing) : base(deserializing) { }
+    private AlbaStochasticTranslocationSingleMoveGenerator(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaStochasticTranslocationSingleMoveGenerator()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/ThreeOpt/AlbaTranslocationMove.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/ThreeOpt/AlbaTranslocationMove.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/ThreeOpt/AlbaTranslocationMove.cs	(revision 15018)
@@ -43,5 +43,5 @@
 
     [StorableConstructor]
-    protected AlbaTranslocationMove(bool deserializing) : base(deserializing) { }
+    protected AlbaTranslocationMove(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/ThreeOpt/AlbaTranslocationMoveEvaluator.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/ThreeOpt/AlbaTranslocationMoveEvaluator.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/ThreeOpt/AlbaTranslocationMoveEvaluator.cs	(revision 15018)
@@ -41,5 +41,5 @@
 
     [StorableConstructor]
-    private AlbaTranslocationMoveEvaluator(bool deserializing) : base(deserializing) { }
+    private AlbaTranslocationMoveEvaluator(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaTranslocationMoveEvaluator()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/ThreeOpt/AlbaTranslocationMoveGenerator.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/ThreeOpt/AlbaTranslocationMoveGenerator.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/ThreeOpt/AlbaTranslocationMoveGenerator.cs	(revision 15018)
@@ -74,5 +74,5 @@
 
     [StorableConstructor]
-    private AlbaTranslocationMoveGenerator(bool deserializing) : base(deserializing) { }
+    private AlbaTranslocationMoveGenerator(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaTranslocationMoveGenerator()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/ThreeOpt/AlbaTranslocationMoveHardTabuCriterion.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/ThreeOpt/AlbaTranslocationMoveHardTabuCriterion.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/ThreeOpt/AlbaTranslocationMoveHardTabuCriterion.cs	(revision 15018)
@@ -65,5 +65,5 @@
 
     [StorableConstructor]
-    private AlbaTranslocationMoveHardTabuCriterion(bool deserializing) : base(deserializing) { }
+    private AlbaTranslocationMoveHardTabuCriterion(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaTranslocationMoveHardTabuCriterion()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/ThreeOpt/AlbaTranslocationMoveMaker.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/ThreeOpt/AlbaTranslocationMoveMaker.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/ThreeOpt/AlbaTranslocationMoveMaker.cs	(revision 15018)
@@ -45,5 +45,5 @@
 
     [StorableConstructor]
-    private AlbaTranslocationMoveMaker(bool deserializing) : base(deserializing) { }
+    private AlbaTranslocationMoveMaker(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaTranslocationMoveMaker()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/ThreeOpt/AlbaTranslocationMoveSoftTabuCriterion.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/ThreeOpt/AlbaTranslocationMoveSoftTabuCriterion.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/ThreeOpt/AlbaTranslocationMoveSoftTabuCriterion.cs	(revision 15018)
@@ -65,5 +65,5 @@
 
     [StorableConstructor]
-    private AlbaTranslocationMoveSoftTabuCriterion(bool deserializing) : base(deserializing) { }
+    private AlbaTranslocationMoveSoftTabuCriterion(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaTranslocationMoveSoftTabuCriterion()
Index: branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/ThreeOpt/AlbaTranslocationMoveTabuMaker.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/ThreeOpt/AlbaTranslocationMoveTabuMaker.cs	(revision 14929)
+++ branches/PersistenceReintegration/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Moves/ThreeOpt/AlbaTranslocationMoveTabuMaker.cs	(revision 15018)
@@ -65,5 +65,5 @@
 
     [StorableConstructor]
-    private AlbaTranslocationMoveTabuMaker(bool deserializing) : base(deserializing) { }
+    private AlbaTranslocationMoveTabuMaker(StorableConstructorFlag deserializing) : base(deserializing) { }
 
     public AlbaTranslocationMoveTabuMaker()