Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.Designer.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.Designer.cs	(revision 15012)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.Designer.cs	(revision 15019)
@@ -75,4 +75,9 @@
       this.SuspendLayout();
       // 
+      // rowsLabel
+      // 
+      this.rowsLabel.Size = new System.Drawing.Size(55, 13);
+      this.rowsLabel.Text = "Datarows:";
+      // 
       // rowsTextBox
       // 
@@ -87,4 +92,9 @@
       this.columnsTextBox.Size = new System.Drawing.Size(71, 20);
       // 
+      // columnsLabel
+      // 
+      this.columnsLabel.Size = new System.Drawing.Size(53, 13);
+      this.columnsLabel.Text = "Variables:";
+      // 
       // statisticsTextBox
       // 
@@ -93,5 +103,5 @@
       // btnApplySort
       // 
-      this.btnApplySort.Location = new System.Drawing.Point(234, 0);
+      this.btnApplySort.Location = new System.Drawing.Point(228, 0);
       this.btnApplySort.Name = "btnApplySort";
       this.btnApplySort.Size = new System.Drawing.Size(104, 23);
@@ -121,5 +131,5 @@
       this.replaceValueOverColumnToolStripMenuItem.Name = "replaceValueOverColumnToolStripMenuItem";
       this.replaceValueOverColumnToolStripMenuItem.Size = new System.Drawing.Size(223, 22);
-      this.replaceValueOverColumnToolStripMenuItem.Text = "Replace Value over Column";
+      this.replaceValueOverColumnToolStripMenuItem.Text = "Replace Value over Variable";
       // 
       // averageToolStripMenuItem_Column
@@ -206,5 +216,5 @@
       // btnSearch
       // 
-      this.btnSearch.Location = new System.Drawing.Point(173, 0);
+      this.btnSearch.Location = new System.Drawing.Point(167, 0);
       this.btnSearch.Name = "btnSearch";
       this.btnSearch.Size = new System.Drawing.Size(55, 23);
@@ -217,5 +227,5 @@
       // btnReplace
       // 
-      this.btnReplace.Location = new System.Drawing.Point(173, 26);
+      this.btnReplace.Location = new System.Drawing.Point(167, 26);
       this.btnReplace.Name = "btnReplace";
       this.btnReplace.Size = new System.Drawing.Size(55, 23);
@@ -233,5 +243,5 @@
       this.checkInputsTargetButton.Size = new System.Drawing.Size(24, 24);
       this.checkInputsTargetButton.TabIndex = 14;
-      this.toolTip.SetToolTip(this.checkInputsTargetButton, "Inputs & Target");
+      this.toolTip.SetToolTip(this.checkInputsTargetButton, "Select Inputs & Target");
       this.checkInputsTargetButton.UseVisualStyleBackColor = true;
       this.checkInputsTargetButton.Click += new System.EventHandler(this.checkInputsTargetButton_Click);
@@ -244,5 +254,5 @@
       this.uncheckAllButton.Size = new System.Drawing.Size(24, 24);
       this.uncheckAllButton.TabIndex = 12;
-      this.toolTip.SetToolTip(this.uncheckAllButton, "None");
+      this.toolTip.SetToolTip(this.uncheckAllButton, "Select None");
       this.uncheckAllButton.UseVisualStyleBackColor = true;
       this.uncheckAllButton.Click += new System.EventHandler(this.uncheckAllButton_Click);
@@ -255,5 +265,5 @@
       this.checkAllButton.Size = new System.Drawing.Size(24, 24);
       this.checkAllButton.TabIndex = 13;
-      this.toolTip.SetToolTip(this.checkAllButton, "All");
+      this.toolTip.SetToolTip(this.checkAllButton, "Select All");
       this.checkAllButton.UseVisualStyleBackColor = true;
       this.checkAllButton.Click += new System.EventHandler(this.checkAllButton_Click);
@@ -261,9 +271,9 @@
       // addRowButton
       // 
-      this.addRowButton.Location = new System.Drawing.Point(344, 26);
+      this.addRowButton.Location = new System.Drawing.Point(338, 26);
       this.addRowButton.Name = "addRowButton";
-      this.addRowButton.Size = new System.Drawing.Size(76, 23);
+      this.addRowButton.Size = new System.Drawing.Size(83, 23);
       this.addRowButton.TabIndex = 10;
-      this.addRowButton.Text = "Add Row";
+      this.addRowButton.Text = "Add Datarow";
       this.addRowButton.UseVisualStyleBackColor = true;
       this.addRowButton.Click += new System.EventHandler(this.addRowButton_Click);
@@ -271,9 +281,9 @@
       // addColumnButton
       // 
-      this.addColumnButton.Location = new System.Drawing.Point(344, 0);
+      this.addColumnButton.Location = new System.Drawing.Point(338, 0);
       this.addColumnButton.Name = "addColumnButton";
-      this.addColumnButton.Size = new System.Drawing.Size(76, 23);
+      this.addColumnButton.Size = new System.Drawing.Size(83, 23);
       this.addColumnButton.TabIndex = 10;
-      this.addColumnButton.Text = "Add Column";
+      this.addColumnButton.Text = "Add Variable";
       this.addColumnButton.UseVisualStyleBackColor = true;
       this.addColumnButton.Click += new System.EventHandler(this.addColumnButton_Click);
@@ -281,9 +291,9 @@
       // renameColumnsButton
       // 
-      this.renameColumnsButton.Location = new System.Drawing.Point(234, 26);
+      this.renameColumnsButton.Location = new System.Drawing.Point(228, 26);
       this.renameColumnsButton.Name = "renameColumnsButton";
       this.renameColumnsButton.Size = new System.Drawing.Size(104, 23);
       this.renameColumnsButton.TabIndex = 11;
-      this.renameColumnsButton.Text = "Rename Columns";
+      this.renameColumnsButton.Text = "Rename Variables";
       this.renameColumnsButton.UseVisualStyleBackColor = true;
       this.renameColumnsButton.Click += new System.EventHandler(this.renameColumnsButton_Click);
Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/LineChartView.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/LineChartView.cs	(revision 15012)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/LineChartView.cs	(revision 15019)
@@ -72,5 +72,5 @@
       if (Content.AllInOneMode) {
         if (allInOneDataTableView == null)
-          allInOneDataTableView = new DataTableView() { Content = allInOneDataTable };
+          allInOneDataTableView = new DataTableView() { Content = allInOneDataTable, ShowName = false };
         return new[] { allInOneDataTableView };
       }
Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingCheckedVariablesView.Designer.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingCheckedVariablesView.Designer.cs	(revision 15012)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingCheckedVariablesView.Designer.cs	(revision 15019)
@@ -70,5 +70,5 @@
       // 
       this.splitContainer.Panel1.Controls.Add(this.variablesGroupBox);
-      this.splitContainer.Size = new System.Drawing.Size(654, 403);
+      this.splitContainer.Size = new System.Drawing.Size(940, 698);
       this.splitContainer.SplitterDistance = 180;
       this.splitContainer.TabIndex = 7;
@@ -83,5 +83,5 @@
       this.variablesGroupBox.Location = new System.Drawing.Point(0, 0);
       this.variablesGroupBox.Name = "variablesGroupBox";
-      this.variablesGroupBox.Size = new System.Drawing.Size(180, 403);
+      this.variablesGroupBox.Size = new System.Drawing.Size(180, 698);
       this.variablesGroupBox.TabIndex = 7;
       this.variablesGroupBox.TabStop = false;
@@ -95,5 +95,5 @@
       this.uncheckAllButton.Size = new System.Drawing.Size(24, 24);
       this.uncheckAllButton.TabIndex = 9;
-      this.toolTip.SetToolTip(this.uncheckAllButton, "None");
+      this.toolTip.SetToolTip(this.uncheckAllButton, "Show None");
       this.uncheckAllButton.UseVisualStyleBackColor = true;
       this.uncheckAllButton.Click += new System.EventHandler(this.uncheckAllButton_Click);
@@ -106,5 +106,5 @@
       this.checkAllButton.Size = new System.Drawing.Size(24, 24);
       this.checkAllButton.TabIndex = 7;
-      this.toolTip.SetToolTip(this.checkAllButton, "All");
+      this.toolTip.SetToolTip(this.checkAllButton, "Show All");
       this.checkAllButton.UseVisualStyleBackColor = true;
       this.checkAllButton.Click += new System.EventHandler(this.checkAllButton_Click);
@@ -117,5 +117,5 @@
       this.checkInputsTargetButton.Size = new System.Drawing.Size(24, 24);
       this.checkInputsTargetButton.TabIndex = 8;
-      this.toolTip.SetToolTip(this.checkInputsTargetButton, "Inputs & Target");
+      this.toolTip.SetToolTip(this.checkInputsTargetButton, "Show Inputs & Target");
       this.checkInputsTargetButton.UseVisualStyleBackColor = true;
       this.checkInputsTargetButton.Click += new System.EventHandler(this.checkInputsTargetButton_Click);
@@ -133,5 +133,5 @@
       this.variablesListView.Location = new System.Drawing.Point(6, 49);
       this.variablesListView.Name = "variablesListView";
-      this.variablesListView.Size = new System.Drawing.Size(168, 348);
+      this.variablesListView.Size = new System.Drawing.Size(168, 643);
       this.variablesListView.TabIndex = 12;
       this.variablesListView.UseCompatibleStateImageBehavior = false;
@@ -149,5 +149,5 @@
       this.Controls.Add(this.splitContainer);
       this.Name = "PreprocessingCheckedVariablesView";
-      this.Size = new System.Drawing.Size(654, 403);
+      this.Size = new System.Drawing.Size(940, 698);
       this.splitContainer.Panel1.ResumeLayout(false);
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).EndInit();
@@ -160,11 +160,11 @@
     #endregion
     protected System.Windows.Forms.SplitContainer splitContainer;
-    private System.Windows.Forms.ListView variablesListView;
-    private System.Windows.Forms.GroupBox variablesGroupBox;
     private System.Windows.Forms.ToolTip toolTip;
     private System.Windows.Forms.ColumnHeader columnHeader;
-    private System.Windows.Forms.Button checkInputsTargetButton;
-    private System.Windows.Forms.Button uncheckAllButton;
-    private System.Windows.Forms.Button checkAllButton;
+    protected System.Windows.Forms.ListView variablesListView;
+    protected System.Windows.Forms.GroupBox variablesGroupBox;
+    protected System.Windows.Forms.Button checkInputsTargetButton;
+    protected System.Windows.Forms.Button uncheckAllButton;
+    protected System.Windows.Forms.Button checkAllButton;
   }
 }
Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotMultiView.Designer.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotMultiView.Designer.cs	(revision 15012)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotMultiView.Designer.cs	(revision 15019)
@@ -80,4 +80,5 @@
       this.splitContainer.Panel2.SuspendLayout();
       this.splitContainer.SuspendLayout();
+      this.variablesGroupBox.SuspendLayout();
       this.frameTableLayoutPanel.SuspendLayout();
       this.columnHeaderScrollPanel.SuspendLayout();
@@ -109,4 +110,13 @@
       // 
       this.splitContainer.Panel2.Controls.Add(this.frameTableLayoutPanel);
+      this.splitContainer.Size = new System.Drawing.Size(940, 698);
+      // 
+      // variablesListView
+      // 
+      this.variablesListView.Size = new System.Drawing.Size(168, 270);
+      // 
+      // variablesGroupBox
+      // 
+      this.variablesGroupBox.Size = new System.Drawing.Size(180, 325);
       // 
       // frameTableLayoutPanel
@@ -124,5 +134,5 @@
       this.frameTableLayoutPanel.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 40F));
       this.frameTableLayoutPanel.RowStyles.Add(new System.Windows.Forms.RowStyle());
-      this.frameTableLayoutPanel.Size = new System.Drawing.Size(470, 403);
+      this.frameTableLayoutPanel.Size = new System.Drawing.Size(756, 698);
       this.frameTableLayoutPanel.TabIndex = 0;
       // 
@@ -134,5 +144,5 @@
       this.columnHeaderScrollPanel.Margin = new System.Windows.Forms.Padding(0);
       this.columnHeaderScrollPanel.Name = "columnHeaderScrollPanel";
-      this.columnHeaderScrollPanel.Size = new System.Drawing.Size(699, 40);
+      this.columnHeaderScrollPanel.Size = new System.Drawing.Size(716, 40);
       this.columnHeaderScrollPanel.TabIndex = 3;
       // 
@@ -161,5 +171,5 @@
       this.rowHeaderScrollPanel.Margin = new System.Windows.Forms.Padding(0);
       this.rowHeaderScrollPanel.Name = "rowHeaderScrollPanel";
-      this.rowHeaderScrollPanel.Size = new System.Drawing.Size(40, 480);
+      this.rowHeaderScrollPanel.Size = new System.Drawing.Size(40, 658);
       this.rowHeaderScrollPanel.TabIndex = 4;
       // 
@@ -189,5 +199,5 @@
       this.bodyScrollPanel.Margin = new System.Windows.Forms.Padding(0);
       this.bodyScrollPanel.Name = "bodyScrollPanel";
-      this.bodyScrollPanel.Size = new System.Drawing.Size(699, 480);
+      this.bodyScrollPanel.Size = new System.Drawing.Size(716, 658);
       this.bodyScrollPanel.TabIndex = 5;
       this.bodyScrollPanel.Scroll += new System.Windows.Forms.ScrollEventHandler(this.bodyScrollPanel_Scroll);
@@ -217,7 +227,7 @@
       this.sizeGroupBox.Controls.Add(this.lockAspectCheckBox);
       this.sizeGroupBox.Dock = System.Windows.Forms.DockStyle.Bottom;
-      this.sizeGroupBox.Location = new System.Drawing.Point(0, 30);
+      this.sizeGroupBox.Location = new System.Drawing.Point(0, 325);
       this.sizeGroupBox.Name = "sizeGroupBox";
-      this.sizeGroupBox.Size = new System.Drawing.Size(180, 94);
+      this.sizeGroupBox.Size = new System.Drawing.Size(180, 98);
       this.sizeGroupBox.TabIndex = 5;
       this.sizeGroupBox.TabStop = false;
@@ -233,5 +243,5 @@
             0,
             0});
-      this.heightNumericUpDown.Location = new System.Drawing.Point(50, 40);
+      this.heightNumericUpDown.Location = new System.Drawing.Point(50, 46);
       this.heightNumericUpDown.Maximum = new decimal(new int[] {
             100000,
@@ -258,5 +268,5 @@
             0,
             0});
-      this.widthNumericUpDown.Location = new System.Drawing.Point(50, 14);
+      this.widthNumericUpDown.Location = new System.Drawing.Point(50, 20);
       this.widthNumericUpDown.Maximum = new decimal(new int[] {
             10000,
@@ -277,5 +287,5 @@
       // 
       this.heightLabel.AutoSize = true;
-      this.heightLabel.Location = new System.Drawing.Point(6, 42);
+      this.heightLabel.Location = new System.Drawing.Point(6, 48);
       this.heightLabel.Name = "heightLabel";
       this.heightLabel.Size = new System.Drawing.Size(41, 13);
@@ -286,5 +296,5 @@
       // 
       this.widthLabel.AutoSize = true;
-      this.widthLabel.Location = new System.Drawing.Point(6, 16);
+      this.widthLabel.Location = new System.Drawing.Point(6, 22);
       this.widthLabel.Name = "widthLabel";
       this.widthLabel.Size = new System.Drawing.Size(38, 13);
@@ -297,5 +307,5 @@
       this.lockAspectCheckBox.Checked = true;
       this.lockAspectCheckBox.CheckState = System.Windows.Forms.CheckState.Checked;
-      this.lockAspectCheckBox.Location = new System.Drawing.Point(50, 66);
+      this.lockAspectCheckBox.Location = new System.Drawing.Point(50, 73);
       this.lockAspectCheckBox.Name = "lockAspectCheckBox";
       this.lockAspectCheckBox.Size = new System.Drawing.Size(114, 17);
@@ -345,7 +355,7 @@
       this.regressionGroupBox.Controls.Add(this.regressionTyleLabel);
       this.regressionGroupBox.Dock = System.Windows.Forms.DockStyle.Bottom;
-      this.regressionGroupBox.Location = new System.Drawing.Point(0, 322);
+      this.regressionGroupBox.Location = new System.Drawing.Point(0, 623);
       this.regressionGroupBox.Name = "regressionGroupBox";
-      this.regressionGroupBox.Size = new System.Drawing.Size(180, 81);
+      this.regressionGroupBox.Size = new System.Drawing.Size(180, 75);
       this.regressionGroupBox.TabIndex = 3;
       this.regressionGroupBox.TabStop = false;
@@ -415,7 +425,7 @@
       this.groupingOptionsBox.Controls.Add(this.groupingComboBox);
       this.groupingOptionsBox.Dock = System.Windows.Forms.DockStyle.Bottom;
-      this.groupingOptionsBox.Location = new System.Drawing.Point(0, 193);
+      this.groupingOptionsBox.Location = new System.Drawing.Point(0, 492);
       this.groupingOptionsBox.Name = "groupingOptionsBox";
-      this.groupingOptionsBox.Size = new System.Drawing.Size(180, 129);
+      this.groupingOptionsBox.Size = new System.Drawing.Size(180, 131);
       this.groupingOptionsBox.TabIndex = 8;
       this.groupingOptionsBox.TabStop = false;
@@ -428,7 +438,7 @@
       this.legendGroupBox.Controls.Add(this.legendOrderLabel);
       this.legendGroupBox.Enabled = false;
-      this.legendGroupBox.Location = new System.Drawing.Point(9, 73);
+      this.legendGroupBox.Location = new System.Drawing.Point(6, 73);
       this.legendGroupBox.Name = "legendGroupBox";
-      this.legendGroupBox.Size = new System.Drawing.Size(164, 50);
+      this.legendGroupBox.Size = new System.Drawing.Size(167, 50);
       this.legendGroupBox.TabIndex = 7;
       this.legendGroupBox.TabStop = false;
@@ -545,5 +555,5 @@
       this.pointsGroupBox.Controls.Add(this.opacityLabel);
       this.pointsGroupBox.Dock = System.Windows.Forms.DockStyle.Bottom;
-      this.pointsGroupBox.Location = new System.Drawing.Point(0, 124);
+      this.pointsGroupBox.Location = new System.Drawing.Point(0, 423);
       this.pointsGroupBox.Name = "pointsGroupBox";
       this.pointsGroupBox.Size = new System.Drawing.Size(180, 69);
@@ -557,8 +567,10 @@
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
       this.Name = "ScatterPlotMultiView";
+      this.Size = new System.Drawing.Size(940, 698);
       this.splitContainer.Panel1.ResumeLayout(false);
       this.splitContainer.Panel2.ResumeLayout(false);
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).EndInit();
       this.splitContainer.ResumeLayout(false);
+      this.variablesGroupBox.ResumeLayout(false);
       this.frameTableLayoutPanel.ResumeLayout(false);
       this.columnHeaderScrollPanel.ResumeLayout(false);
Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotSingleView.Designer.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotSingleView.Designer.cs	(revision 15012)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotSingleView.Designer.cs	(revision 15019)
@@ -86,5 +86,5 @@
       this.scatterPlotView.Name = "scatterPlotView";
       this.scatterPlotView.ReadOnly = false;
-      this.scatterPlotView.ShowName = true;
+      this.scatterPlotView.ShowName = false;
       this.scatterPlotView.Size = new System.Drawing.Size(618, 517);
       this.scatterPlotView.TabIndex = 0;
@@ -188,4 +188,5 @@
       this.comboBoxYVariable.AutoCompleteMode = System.Windows.Forms.AutoCompleteMode.Suggest;
       this.comboBoxYVariable.AutoCompleteSource = System.Windows.Forms.AutoCompleteSource.ListItems;
+      this.comboBoxYVariable.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
       this.comboBoxYVariable.FormattingEnabled = true;
       this.comboBoxYVariable.Location = new System.Drawing.Point(51, 60);
@@ -202,4 +203,5 @@
       this.comboBoxXVariable.AutoCompleteMode = System.Windows.Forms.AutoCompleteMode.Suggest;
       this.comboBoxXVariable.AutoCompleteSource = System.Windows.Forms.AutoCompleteSource.ListItems;
+      this.comboBoxXVariable.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
       this.comboBoxXVariable.FormattingEnabled = true;
       this.comboBoxXVariable.Location = new System.Drawing.Point(51, 26);
Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/StatisticsView.Designer.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/StatisticsView.Designer.cs	(revision 15012)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/StatisticsView.Designer.cs	(revision 15019)
@@ -81,7 +81,7 @@
       this.lblRows.Location = new System.Drawing.Point(3, 0);
       this.lblRows.Name = "lblRows";
-      this.lblRows.Size = new System.Drawing.Size(47, 26);
+      this.lblRows.Size = new System.Drawing.Size(52, 26);
       this.lblRows.TabIndex = 0;
-      this.lblRows.Text = "Rows";
+      this.lblRows.Text = "Datarows";
       this.lblRows.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
       // 
@@ -92,7 +92,7 @@
       this.lblColumns.Location = new System.Drawing.Point(3, 26);
       this.lblColumns.Name = "lblColumns";
-      this.lblColumns.Size = new System.Drawing.Size(47, 26);
+      this.lblColumns.Size = new System.Drawing.Size(52, 26);
       this.lblColumns.TabIndex = 2;
-      this.lblColumns.Text = "Columns";
+      this.lblColumns.Text = "Variables";
       this.lblColumns.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
       // 
@@ -101,5 +101,5 @@
       this.lblMissingValuesTotal.AutoSize = true;
       this.lblMissingValuesTotal.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.lblMissingValuesTotal.Location = new System.Drawing.Point(233, 26);
+      this.lblMissingValuesTotal.Location = new System.Drawing.Point(237, 26);
       this.lblMissingValuesTotal.Name = "lblMissingValuesTotal";
       this.lblMissingValuesTotal.Size = new System.Drawing.Size(77, 26);
@@ -112,9 +112,9 @@
       this.lblNumericColumns.AutoSize = true;
       this.lblNumericColumns.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.lblNumericColumns.Location = new System.Drawing.Point(97, 0);
+      this.lblNumericColumns.Location = new System.Drawing.Point(100, 0);
       this.lblNumericColumns.Name = "lblNumericColumns";
-      this.lblNumericColumns.Size = new System.Drawing.Size(89, 26);
+      this.lblNumericColumns.Size = new System.Drawing.Size(92, 26);
       this.lblNumericColumns.TabIndex = 3;
-      this.lblNumericColumns.Text = "Numeric Columns";
+      this.lblNumericColumns.Text = "Numeric Variables";
       this.lblNumericColumns.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
       // 
@@ -123,9 +123,9 @@
       this.lblNominalColumns.AutoSize = true;
       this.lblNominalColumns.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.lblNominalColumns.Location = new System.Drawing.Point(97, 26);
+      this.lblNominalColumns.Location = new System.Drawing.Point(100, 26);
       this.lblNominalColumns.Name = "lblNominalColumns";
-      this.lblNominalColumns.Size = new System.Drawing.Size(89, 26);
+      this.lblNominalColumns.Size = new System.Drawing.Size(92, 26);
       this.lblNominalColumns.TabIndex = 3;
-      this.lblNominalColumns.Text = "Nominal Columns";
+      this.lblNominalColumns.Text = "Nominal Variables";
       this.lblNominalColumns.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
       // 
@@ -152,5 +152,5 @@
       this.showVariablesGroupBox.Location = new System.Drawing.Point(393, 0);
       this.showVariablesGroupBox.Name = "showVariablesGroupBox";
-      this.showVariablesGroupBox.Size = new System.Drawing.Size(97, 55);
+      this.showVariablesGroupBox.Size = new System.Drawing.Size(97, 71);
       this.showVariablesGroupBox.TabIndex = 16;
       this.showVariablesGroupBox.TabStop = false;
@@ -164,5 +164,5 @@
       this.checkInputsTargetButton.Size = new System.Drawing.Size(24, 24);
       this.checkInputsTargetButton.TabIndex = 14;
-      this.toolTip.SetToolTip(this.checkInputsTargetButton, "Inputs & Target");
+      this.toolTip.SetToolTip(this.checkInputsTargetButton, "Show Inputs & Target");
       this.checkInputsTargetButton.UseVisualStyleBackColor = true;
       this.checkInputsTargetButton.Click += new System.EventHandler(this.checkInputsTargetButton_Click);
@@ -175,5 +175,5 @@
       this.uncheckAllButton.Size = new System.Drawing.Size(24, 24);
       this.uncheckAllButton.TabIndex = 12;
-      this.toolTip.SetToolTip(this.uncheckAllButton, "None");
+      this.toolTip.SetToolTip(this.uncheckAllButton, "Show None");
       this.uncheckAllButton.UseVisualStyleBackColor = true;
       this.uncheckAllButton.Click += new System.EventHandler(this.uncheckAllButton_Click);
@@ -186,5 +186,5 @@
       this.checkAllButton.Size = new System.Drawing.Size(24, 24);
       this.checkAllButton.TabIndex = 13;
-      this.toolTip.SetToolTip(this.checkAllButton, "All");
+      this.toolTip.SetToolTip(this.checkAllButton, "Show All");
       this.checkAllButton.UseVisualStyleBackColor = true;
       this.checkAllButton.Click += new System.EventHandler(this.checkAllButton_Click);
@@ -194,5 +194,5 @@
       this.lblTNumValues.AutoSize = true;
       this.lblTNumValues.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.lblTNumValues.Location = new System.Drawing.Point(233, 0);
+      this.lblTNumValues.Location = new System.Drawing.Point(237, 0);
       this.lblTNumValues.Name = "lblTNumValues";
       this.lblTNumValues.Size = new System.Drawing.Size(77, 26);
@@ -208,5 +208,5 @@
       this.orientationGroupBox.Location = new System.Drawing.Point(496, 0);
       this.orientationGroupBox.Name = "orientationGroupBox";
-      this.orientationGroupBox.Size = new System.Drawing.Size(94, 55);
+      this.orientationGroupBox.Size = new System.Drawing.Size(94, 71);
       this.orientationGroupBox.TabIndex = 17;
       this.orientationGroupBox.TabStop = false;
@@ -241,8 +241,8 @@
       // 
       this.rowsTextBox.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.rowsTextBox.Location = new System.Drawing.Point(56, 3);
+      this.rowsTextBox.Location = new System.Drawing.Point(61, 3);
       this.rowsTextBox.Name = "rowsTextBox";
       this.rowsTextBox.ReadOnly = true;
-      this.rowsTextBox.Size = new System.Drawing.Size(35, 20);
+      this.rowsTextBox.Size = new System.Drawing.Size(33, 20);
       this.rowsTextBox.TabIndex = 18;
       // 
@@ -250,8 +250,8 @@
       // 
       this.columnsTextBox.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.columnsTextBox.Location = new System.Drawing.Point(56, 29);
+      this.columnsTextBox.Location = new System.Drawing.Point(61, 29);
       this.columnsTextBox.Name = "columnsTextBox";
       this.columnsTextBox.ReadOnly = true;
-      this.columnsTextBox.Size = new System.Drawing.Size(35, 20);
+      this.columnsTextBox.Size = new System.Drawing.Size(33, 20);
       this.columnsTextBox.TabIndex = 18;
       // 
@@ -259,8 +259,8 @@
       // 
       this.totalValuesTextBox.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.totalValuesTextBox.Location = new System.Drawing.Point(316, 3);
+      this.totalValuesTextBox.Location = new System.Drawing.Point(320, 3);
       this.totalValuesTextBox.Name = "totalValuesTextBox";
       this.totalValuesTextBox.ReadOnly = true;
-      this.totalValuesTextBox.Size = new System.Drawing.Size(59, 20);
+      this.totalValuesTextBox.Size = new System.Drawing.Size(55, 20);
       this.totalValuesTextBox.TabIndex = 18;
       // 
@@ -299,8 +299,8 @@
       // 
       this.numericColumnsTextBox.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.numericColumnsTextBox.Location = new System.Drawing.Point(192, 3);
+      this.numericColumnsTextBox.Location = new System.Drawing.Point(198, 3);
       this.numericColumnsTextBox.Name = "numericColumnsTextBox";
       this.numericColumnsTextBox.ReadOnly = true;
-      this.numericColumnsTextBox.Size = new System.Drawing.Size(35, 20);
+      this.numericColumnsTextBox.Size = new System.Drawing.Size(33, 20);
       this.numericColumnsTextBox.TabIndex = 18;
       // 
@@ -308,8 +308,8 @@
       // 
       this.nominalColumnsTextBox5.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.nominalColumnsTextBox5.Location = new System.Drawing.Point(192, 29);
+      this.nominalColumnsTextBox5.Location = new System.Drawing.Point(198, 29);
       this.nominalColumnsTextBox5.Name = "nominalColumnsTextBox5";
       this.nominalColumnsTextBox5.ReadOnly = true;
-      this.nominalColumnsTextBox5.Size = new System.Drawing.Size(35, 20);
+      this.nominalColumnsTextBox5.Size = new System.Drawing.Size(33, 20);
       this.nominalColumnsTextBox5.TabIndex = 18;
       // 
@@ -317,8 +317,8 @@
       // 
       this.missingValuesTextBox.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.missingValuesTextBox.Location = new System.Drawing.Point(316, 29);
+      this.missingValuesTextBox.Location = new System.Drawing.Point(320, 29);
       this.missingValuesTextBox.Name = "missingValuesTextBox";
       this.missingValuesTextBox.ReadOnly = true;
-      this.missingValuesTextBox.Size = new System.Drawing.Size(59, 20);
+      this.missingValuesTextBox.Size = new System.Drawing.Size(55, 20);
       this.missingValuesTextBox.TabIndex = 18;
       // 