Index: /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingCheckedVariablesView.Designer.cs
===================================================================
--- /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingCheckedVariablesView.Designer.cs	(revision 15027)
+++ /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingCheckedVariablesView.Designer.cs	(revision 15028)
@@ -48,10 +48,10 @@
       this.splitContainer = new System.Windows.Forms.SplitContainer();
       this.variablesGroupBox = new System.Windows.Forms.GroupBox();
+      this.variablesListView = new System.Windows.Forms.ListView();
+      this.columnHeader = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
+      this.toolTip = new System.Windows.Forms.ToolTip(this.components);
       this.uncheckAllButton = new System.Windows.Forms.Button();
       this.checkAllButton = new System.Windows.Forms.Button();
       this.checkInputsTargetButton = new System.Windows.Forms.Button();
-      this.variablesListView = new System.Windows.Forms.ListView();
-      this.columnHeader = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
-      this.toolTip = new System.Windows.Forms.ToolTip(this.components);
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).BeginInit();
       this.splitContainer.Panel1.SuspendLayout();
@@ -88,4 +88,26 @@
       this.variablesGroupBox.Text = "Variables";
       // 
+      // variablesListView
+      // 
+      this.variablesListView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.variablesListView.CheckBoxes = true;
+      this.variablesListView.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
+            this.columnHeader});
+      this.variablesListView.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.None;
+      this.variablesListView.HideSelection = false;
+      this.variablesListView.Location = new System.Drawing.Point(6, 49);
+      this.variablesListView.Name = "variablesListView";
+      this.variablesListView.Size = new System.Drawing.Size(168, 643);
+      this.variablesListView.TabIndex = 12;
+      this.variablesListView.UseCompatibleStateImageBehavior = false;
+      this.variablesListView.View = System.Windows.Forms.View.Details;
+      // 
+      // columnHeader
+      // 
+      this.columnHeader.Text = "";
+      this.columnHeader.Width = 164;
+      // 
       // uncheckAllButton
       // 
@@ -121,26 +143,4 @@
       this.checkInputsTargetButton.Click += new System.EventHandler(this.checkInputsTargetButton_Click);
       // 
-      // variablesListView
-      // 
-      this.variablesListView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.variablesListView.CheckBoxes = true;
-      this.variablesListView.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
-            this.columnHeader});
-      this.variablesListView.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.None;
-      this.variablesListView.HideSelection = false;
-      this.variablesListView.Location = new System.Drawing.Point(6, 49);
-      this.variablesListView.Name = "variablesListView";
-      this.variablesListView.Size = new System.Drawing.Size(168, 643);
-      this.variablesListView.TabIndex = 12;
-      this.variablesListView.UseCompatibleStateImageBehavior = false;
-      this.variablesListView.View = System.Windows.Forms.View.Details;
-      // 
-      // columnHeader
-      // 
-      this.columnHeader.Text = "";
-      this.columnHeader.Width = 164;
-      // 
       // PreprocessingCheckedVariablesView
       // 
@@ -162,9 +162,9 @@
     private System.Windows.Forms.ToolTip toolTip;
     private System.Windows.Forms.ColumnHeader columnHeader;
-    protected System.Windows.Forms.ListView variablesListView;
-    protected System.Windows.Forms.GroupBox variablesGroupBox;
-    protected System.Windows.Forms.Button checkInputsTargetButton;
-    protected System.Windows.Forms.Button uncheckAllButton;
-    protected System.Windows.Forms.Button checkAllButton;
+    private System.Windows.Forms.ListView variablesListView;
+    private System.Windows.Forms.GroupBox variablesGroupBox;
+    private System.Windows.Forms.Button checkInputsTargetButton;
+    private System.Windows.Forms.Button uncheckAllButton;
+    private System.Windows.Forms.Button checkAllButton;
   }
 }
Index: /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotMultiView.Designer.cs
===================================================================
--- /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotMultiView.Designer.cs	(revision 15027)
+++ /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotMultiView.Designer.cs	(revision 15028)
@@ -80,5 +80,4 @@
       this.splitContainer.Panel2.SuspendLayout();
       this.splitContainer.SuspendLayout();
-      this.variablesGroupBox.SuspendLayout();
       this.frameTableLayoutPanel.SuspendLayout();
       this.columnHeaderScrollPanel.SuspendLayout();
@@ -110,13 +109,5 @@
       // 
       this.splitContainer.Panel2.Controls.Add(this.frameTableLayoutPanel);
-      this.splitContainer.Size = new System.Drawing.Size(940, 698);
-      // 
-      // variablesListView
-      // 
-      this.variablesListView.Size = new System.Drawing.Size(168, 270);
-      // 
-      // variablesGroupBox
-      // 
-      this.variablesGroupBox.Size = new System.Drawing.Size(180, 325);
+      this.splitContainer.Size = new System.Drawing.Size(589, 451);
       // 
       // frameTableLayoutPanel
@@ -134,5 +125,5 @@
       this.frameTableLayoutPanel.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 40F));
       this.frameTableLayoutPanel.RowStyles.Add(new System.Windows.Forms.RowStyle());
-      this.frameTableLayoutPanel.Size = new System.Drawing.Size(756, 698);
+      this.frameTableLayoutPanel.Size = new System.Drawing.Size(405, 451);
       this.frameTableLayoutPanel.TabIndex = 0;
       // 
@@ -144,5 +135,5 @@
       this.columnHeaderScrollPanel.Margin = new System.Windows.Forms.Padding(0);
       this.columnHeaderScrollPanel.Name = "columnHeaderScrollPanel";
-      this.columnHeaderScrollPanel.Size = new System.Drawing.Size(716, 40);
+      this.columnHeaderScrollPanel.Size = new System.Drawing.Size(365, 40);
       this.columnHeaderScrollPanel.TabIndex = 3;
       // 
@@ -171,5 +162,5 @@
       this.rowHeaderScrollPanel.Margin = new System.Windows.Forms.Padding(0);
       this.rowHeaderScrollPanel.Name = "rowHeaderScrollPanel";
-      this.rowHeaderScrollPanel.Size = new System.Drawing.Size(40, 658);
+      this.rowHeaderScrollPanel.Size = new System.Drawing.Size(40, 411);
       this.rowHeaderScrollPanel.TabIndex = 4;
       // 
@@ -199,5 +190,5 @@
       this.bodyScrollPanel.Margin = new System.Windows.Forms.Padding(0);
       this.bodyScrollPanel.Name = "bodyScrollPanel";
-      this.bodyScrollPanel.Size = new System.Drawing.Size(716, 658);
+      this.bodyScrollPanel.Size = new System.Drawing.Size(365, 411);
       this.bodyScrollPanel.TabIndex = 5;
       this.bodyScrollPanel.Scroll += new System.Windows.Forms.ScrollEventHandler(this.bodyScrollPanel_Scroll);
@@ -227,5 +218,5 @@
       this.sizeGroupBox.Controls.Add(this.lockAspectCheckBox);
       this.sizeGroupBox.Dock = System.Windows.Forms.DockStyle.Bottom;
-      this.sizeGroupBox.Location = new System.Drawing.Point(0, 325);
+      this.sizeGroupBox.Location = new System.Drawing.Point(0, 78);
       this.sizeGroupBox.Name = "sizeGroupBox";
       this.sizeGroupBox.Size = new System.Drawing.Size(180, 98);
@@ -355,5 +346,5 @@
       this.regressionGroupBox.Controls.Add(this.regressionTyleLabel);
       this.regressionGroupBox.Dock = System.Windows.Forms.DockStyle.Bottom;
-      this.regressionGroupBox.Location = new System.Drawing.Point(0, 623);
+      this.regressionGroupBox.Location = new System.Drawing.Point(0, 376);
       this.regressionGroupBox.Name = "regressionGroupBox";
       this.regressionGroupBox.Size = new System.Drawing.Size(180, 75);
@@ -425,5 +416,5 @@
       this.groupingOptionsBox.Controls.Add(this.groupingComboBox);
       this.groupingOptionsBox.Dock = System.Windows.Forms.DockStyle.Bottom;
-      this.groupingOptionsBox.Location = new System.Drawing.Point(0, 492);
+      this.groupingOptionsBox.Location = new System.Drawing.Point(0, 245);
       this.groupingOptionsBox.Name = "groupingOptionsBox";
       this.groupingOptionsBox.Size = new System.Drawing.Size(180, 131);
@@ -555,5 +546,5 @@
       this.pointsGroupBox.Controls.Add(this.opacityLabel);
       this.pointsGroupBox.Dock = System.Windows.Forms.DockStyle.Bottom;
-      this.pointsGroupBox.Location = new System.Drawing.Point(0, 423);
+      this.pointsGroupBox.Location = new System.Drawing.Point(0, 176);
       this.pointsGroupBox.Name = "pointsGroupBox";
       this.pointsGroupBox.Size = new System.Drawing.Size(180, 69);
@@ -567,10 +558,9 @@
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
       this.Name = "ScatterPlotMultiView";
-      this.Size = new System.Drawing.Size(940, 698);
+      this.Size = new System.Drawing.Size(589, 451);
       this.splitContainer.Panel1.ResumeLayout(false);
       this.splitContainer.Panel2.ResumeLayout(false);
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).EndInit();
       this.splitContainer.ResumeLayout(false);
-      this.variablesGroupBox.ResumeLayout(false);
       this.frameTableLayoutPanel.ResumeLayout(false);
       this.columnHeaderScrollPanel.ResumeLayout(false);