Index: stable/HeuristicLab.Core.Views/3.3/HeuristicLab.Core.Views-3.3.csproj
===================================================================
--- stable/HeuristicLab.Core.Views/3.3/HeuristicLab.Core.Views-3.3.csproj	(revision 14988)
+++ stable/HeuristicLab.Core.Views/3.3/HeuristicLab.Core.Views-3.3.csproj	(revision 15038)
@@ -122,4 +122,5 @@
   </ItemGroup>
   <ItemGroup>
+    <None Include="app.config" />
     <None Include="Plugin.cs.frame" />
     <Compile Include="BreadcrumbViewHost.cs">
@@ -172,4 +173,9 @@
     </Compile>
     <Compile Include="Plugin.cs" />
+    <Compile Include="Properties\Settings.Designer.cs">
+      <AutoGen>True</AutoGen>
+      <DesignTimeSharedInput>True</DesignTimeSharedInput>
+      <DependentUpon>Settings.settings</DependentUpon>
+    </Compile>
     <Compile Include="VariableValueView.cs">
       <SubType>UserControl</SubType>
@@ -329,4 +335,8 @@
       <DependentUpon>VariableView.cs</DependentUpon>
     </Compile>
+    <None Include="Properties\Settings.settings">
+      <Generator>PublicSettingsSingleFileGenerator</Generator>
+      <LastGenOutput>Settings.Designer.cs</LastGenOutput>
+    </None>
   </ItemGroup>
   <ItemGroup>
Index: stable/HeuristicLab.Core.Views/3.3/ItemView.cs
===================================================================
--- stable/HeuristicLab.Core.Views/3.3/ItemView.cs	(revision 14988)
+++ stable/HeuristicLab.Core.Views/3.3/ItemView.cs	(revision 15038)
@@ -29,6 +29,4 @@
   /// </summary>
   public partial class ItemView : AsynchronousContentView {
-    public const int MaximumNestingLevel = 35;
-
     public new IItem Content {
       get { return (IItem)base.Content; }
@@ -46,5 +44,5 @@
       base.OnInitialized(e);
 
-      if (CountParentControls() > MaximumNestingLevel) {
+      if (CountParentControls() > Properties.Settings.Default.MaximumNestedControls) {
         //capture content, needed because it is set at a later time
         NestingLevelErrorControl errorControl = new NestingLevelErrorControl(() => Content, this.GetType());
Index: stable/HeuristicLab.Core.Views/3.3/Properties/Settings.Designer.cs
===================================================================
--- stable/HeuristicLab.Core.Views/3.3/Properties/Settings.Designer.cs	(revision 15038)
+++ stable/HeuristicLab.Core.Views/3.3/Properties/Settings.Designer.cs	(revision 15038)
@@ -0,0 +1,38 @@
+﻿//------------------------------------------------------------------------------
+// <auto-generated>
+//     This code was generated by a tool.
+//     Runtime Version:4.0.30319.42000
+//
+//     Changes to this file may cause incorrect behavior and will be lost if
+//     the code is regenerated.
+// </auto-generated>
+//------------------------------------------------------------------------------
+
+namespace HeuristicLab.Core.Views.Properties {
+    
+    
+    [global::System.Runtime.CompilerServices.CompilerGeneratedAttribute()]
+    [global::System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.VisualStudio.Editors.SettingsDesigner.SettingsSingleFileGenerator", "14.0.0.0")]
+    public sealed partial class Settings : global::System.Configuration.ApplicationSettingsBase {
+        
+        private static Settings defaultInstance = ((Settings)(global::System.Configuration.ApplicationSettingsBase.Synchronized(new Settings())));
+        
+        public static Settings Default {
+            get {
+                return defaultInstance;
+            }
+        }
+        
+        [global::System.Configuration.UserScopedSettingAttribute()]
+        [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
+        [global::System.Configuration.DefaultSettingValueAttribute("35")]
+        public int MaximumNestedControls {
+            get {
+                return ((int)(this["MaximumNestedControls"]));
+            }
+            set {
+                this["MaximumNestedControls"] = value;
+            }
+        }
+    }
+}
Index: stable/HeuristicLab.Core.Views/3.3/Properties/Settings.settings
===================================================================
--- stable/HeuristicLab.Core.Views/3.3/Properties/Settings.settings	(revision 15038)
+++ stable/HeuristicLab.Core.Views/3.3/Properties/Settings.settings	(revision 15038)
@@ -0,0 +1,9 @@
+<?xml version='1.0' encoding='utf-8'?>
+<SettingsFile xmlns="http://schemas.microsoft.com/VisualStudio/2004/01/settings" CurrentProfile="(Default)" GeneratedClassNamespace="HeuristicLab.Core.Views.Properties" GeneratedClassName="Settings">
+  <Profiles />
+  <Settings>
+    <Setting Name="MaximumNestedControls" Type="System.Int32" Scope="User">
+      <Value Profile="(Default)">35</Value>
+    </Setting>
+  </Settings>
+</SettingsFile>
Index: stable/HeuristicLab.Core.Views/3.3/app.config
===================================================================
--- stable/HeuristicLab.Core.Views/3.3/app.config	(revision 15038)
+++ stable/HeuristicLab.Core.Views/3.3/app.config	(revision 15038)
@@ -0,0 +1,15 @@
+<?xml version="1.0" encoding="utf-8" ?>
+<configuration>
+    <configSections>
+        <sectionGroup name="userSettings" type="System.Configuration.UserSettingsGroup, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" >
+            <section name="HeuristicLab.Core.Views.Properties.Settings" type="System.Configuration.ClientSettingsSection, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" allowExeDefinition="MachineToLocalUser" requirePermission="false" />
+        </sectionGroup>
+    </configSections>
+    <userSettings>
+        <HeuristicLab.Core.Views.Properties.Settings>
+            <setting name="MaximumNestedControls" serializeAs="String">
+                <value>35</value>
+            </setting>
+        </HeuristicLab.Core.Views.Properties.Settings>
+    </userSettings>
+</configuration>